
/*  A Bison parser, made from /home/rob/src/acapd-2_2/acapd/parse.acap.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse acap_parse
#define yylex acap_lex
#define yyerror acap_error
#define yylval acap_lval
#define yychar acap_char
#define yydebug acap_debug
#define yynerrs acap_nerrs
#define	ACL	258
#define	ALL	259
#define	AND	260
#define	ATTRIBUTE	261
#define	AUTHENTICATE	262
#define	COMPARE	263
#define	COMPARESTRICT	264
#define	CONTENT_TYPE	265
#define	CRLF	266
#define	DEFAULT	267
#define	DELETEACL	268
#define	DELETEDSINCE	269
#define	DEPTH	270
#define	ENUMERATE	271
#define	EQUAL	272
#define	ERROR	273
#define	FREECONTEXT	274
#define	GETQUOTA	275
#define	HARDLIMIT	276
#define	LANG	277
#define	LIMIT	278
#define	LISTRIGHTS	279
#define	LOGOUT	280
#define	MAKECONTEXT	281
#define	MYRIGHTS	282
#define	NIL	283
#define	NOCREATE	284
#define	NOINHERIT	285
#define	NOOP	286
#define	NOT	287
#define	NOTIFY	288
#define	NUMBER	289
#define	OR	290
#define	PREFIX	291
#define	RANGE	292
#define	RETURN	293
#define	SEARCH	294
#define	SETACL	295
#define	SIZE	296
#define	SORT	297
#define	STORE	298
#define	STRING	299
#define	SUBSTRING	300
#define	TAG	301
#define	UNCHANGEDSINCE	302
#define	UPDATECONTEXT	303
#define	VALUE	304

#line 27 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"

#include <config.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <com_err.h>
#include "../util/str.h"
#include "client.h"
#include "command.h"
#include "search_ast.h"
#include "search.h"
#include "store.h"
#include "acap_err.h"
#include "token.acap.h"
#include "criteria.h"

#define YYPARSE_PARAM _client
#define YYLEX_PARAM _client
#define YYERROR_VERBOSE

#undef L_DEFAULT_GUARD
#define L_DEFAULT_GUARD (acap_debug)

#define CHECK_RESULT()				\
  if (result) {					\
    report_error_code(CLIENT, result);		\
    YYERROR;					\
  }


#line 61 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
typedef union {
  str_t *str;
  unsigned long number;
  bool_t boolean;

  struct search_modifier_s *search_modifier;
  struct search_return_s *search_return;
  struct search_return_metadatum_s *search_return_metadatum;
  struct search_sort_s *search_sort;
  struct criterion_s *criterion;

  struct store_s *store;
  struct store_params_s *store_params;
  struct store_entry_s *store_entry;
  struct store_attribute_s *store_attribute;
  struct store_attribute_value_s *store_attribute_value;
  struct store_metadatum_s *store_metadatum;
} YYSTYPE;
#line 80 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"

extern int yylex(YYSTYPE *lvalp, void *client);
static void yyerror(char *s);
static void unimplemented(client_t *client);
static void report_error_code(client_t *client, result_t code);
static result_t add_client_data(client_t *client, void *data);

#define CLIENT ((client_t *)(_client))
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		272
#define	YYFLAG		-32768
#define	YYNTBASE	53

#define YYTRANSLATE(x) ((unsigned)(x) <= 304 ? yytranslate[x] : 109)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,    50,     2,     2,     2,     2,     2,     2,     2,    51,
    52,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     8,    11,    13,    15,    17,    19,    21,
    23,    25,    27,    29,    31,    33,    35,    37,    39,    41,
    48,    55,    62,    68,    74,    79,    81,    85,    87,    95,
    98,   104,   107,   116,   118,   119,   125,   131,   139,   147,
   151,   159,   167,   168,   170,   172,   176,   179,   180,   184,
   186,   190,   192,   193,   195,   197,   201,   205,   206,   209,
   210,   213,   215,   221,   229,   237,   245,   249,   255,   263,
   271,   279,   281,   291,   296,   298,   301,   309,   311,   312,
   316,   321,   323,   327,   331,   333,   337,   339,   341,   343,
   345,   347,   351,   355,   357,   359,   361,   365,   366,   368,
   370,   374,   380,   382,   386,   388,   392,   398,   406,   407,
   410,   411
};

static const short yyrhs[] = {    -1,
    54,    55,     0,    56,    50,    57,     0,     1,    11,     0,
    46,     0,    58,     0,    59,     0,    60,     0,    61,     0,
    62,     0,    63,     0,    66,     0,    67,     0,    68,     0,
    69,     0,    70,     0,    86,     0,    87,     0,   102,     0,
     7,   107,    50,    44,   106,    11,     0,    13,   108,    50,
   105,   106,    11,     0,    14,   108,    50,    44,    44,    11,
     0,    19,   108,    50,    44,    11,     0,    20,   108,    50,
    44,    11,     0,    22,    50,    64,    11,     0,    65,     0,
    64,    50,    65,     0,    44,     0,    24,   108,    50,   105,
    50,    44,    11,     0,    25,    11,     0,    27,   108,    50,
   105,    11,     0,    31,    11,     0,    39,   108,    50,    71,
    72,    50,    84,    11,     0,    44,     0,     0,    72,    50,
    15,    50,    34,     0,    72,    50,    21,    50,    34,     0,
    72,    50,    23,    50,    34,    50,    34,     0,    72,    50,
    26,    50,    82,    83,    44,     0,    72,    50,    30,     0,
    72,    50,    38,    50,    51,    73,    52,     0,    72,    50,
    42,    50,    51,    79,    52,     0,     0,    74,     0,    75,
     0,    74,    50,    75,     0,    44,    76,     0,     0,    51,
    77,    52,     0,    78,     0,    77,    50,    78,     0,    44,
     0,     0,    80,     0,    81,     0,    80,    50,    81,     0,
    44,    50,    44,     0,     0,    16,    50,     0,     0,    33,
    50,     0,     4,     0,     5,    50,    84,    50,    84,     0,
     8,    50,    44,    50,    85,    50,    96,     0,     9,    50,
    44,    50,    85,    50,    96,     0,    17,    50,    44,    50,
    85,    50,    96,     0,    32,    50,    84,     0,    35,    50,
    84,    50,    84,     0,    36,    50,    44,    50,    85,    50,
    96,     0,    37,    50,    34,    50,    34,    50,    44,     0,
    45,    50,    44,    50,    85,    50,    96,     0,    44,     0,
    40,   108,    50,   105,    50,    44,    50,    44,    11,     0,
    43,   108,    88,    11,     0,    89,     0,    88,    89,     0,
    50,    51,    90,    50,    91,    92,    52,     0,    44,     0,
     0,    91,    29,    50,     0,    91,    47,    44,    50,     0,
    93,     0,    92,    50,    93,     0,    44,    50,    94,     0,
    95,     0,    51,    97,    52,     0,    12,     0,    96,     0,
    28,     0,    44,     0,    98,     0,    97,    50,    98,     0,
    44,    50,    99,     0,    44,     0,    28,     0,    12,     0,
    51,   100,    52,     0,     0,   101,     0,    44,     0,   101,
    50,    44,     0,    48,   108,    50,   103,    11,     0,   104,
     0,   103,    50,   104,     0,    44,     0,    51,    44,    52,
     0,    51,    44,    50,    44,    52,     0,    51,    44,    50,
    44,    50,    44,    52,     0,     0,    50,    44,     0,     0,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   160,   161,   165,   166,   172,   177,   178,   179,   180,   181,
   182,   183,   184,   185,   186,   187,   188,   189,   190,   192,
   321,   323,   325,   335,   337,   339,   340,   342,   345,   347,
   359,   361,   369,   385,   395,   400,   406,   412,   418,   424,
   430,   436,   443,   444,   446,   450,   456,   462,   463,   465,
   469,   475,   481,   482,   484,   488,   494,   500,   501,   503,
   504,   506,   512,   518,   524,   530,   536,   542,   548,   554,
   560,   567,   577,   579,   595,   601,   609,   620,   635,   640,
   646,   653,   658,   665,   672,   677,   682,   683,   685,   686,
   688,   694,   702,   718,   723,   728,   733,   738,   742,   744,
   749,   756,   758,   759,   761,   765,   766,   767,   769,   769,
   771,   783
};
#endif

#define YYNTOKENS 53
#define YYNNTS 56
#define YYNRULES 112
#define YYNSTATES 273
#define YYMAXUTOK 304

static const char * const yytname[] = {   "$","error","$undefined.","ACL","ALL",
"AND","ATTRIBUTE","AUTHENTICATE","COMPARE","COMPARESTRICT","CONTENT_TYPE","CRLF",
"DEFAULT","DELETEACL","DELETEDSINCE","DEPTH","ENUMERATE","EQUAL","ERROR","FREECONTEXT",
"GETQUOTA","HARDLIMIT","LANG","LIMIT","LISTRIGHTS","LOGOUT","MAKECONTEXT","MYRIGHTS",
"NIL","NOCREATE","NOINHERIT","NOOP","NOT","NOTIFY","NUMBER","OR","PREFIX","RANGE",
"RETURN","SEARCH","SETACL","SIZE","SORT","STORE","STRING","SUBSTRING","TAG",
"UNCHANGEDSINCE","UPDATECONTEXT","VALUE","' '","'('","')'","top","@1","line",
"tag","command","authenticate","deleteacl","deletedsince","freecontext","getquota",
"lang","lang_tag_list","lang_tag","listrights","logout","myrights","noop","search",
"search_path","search_modifier","search_return_list_maybe","search_return_list",
"search_return","search_return_metadatum_list_maybe","search_return_metadatum_list",
"search_return_metadatum","search_sort_list_maybe","search_sort_list","search_sort",
"maybe_enumerate","maybe_notify","criterion","comparator","setacl","store","store_entry_list",
"store_entry","store_path","store_params","attribute_store_list","attribute_store",
"attribute_store_value","value_nildef","value_nil","metadatum_write_list","metadatum_write",
"metadatum_value","metadatum_string_list_maybe","metadatum_string_list","updatecontext",
"context_list","context","acl_object","optional_string","check_no_auth","check_auth", NULL
};
static const short yytoknum[] = { 0,
   256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
   266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
   296,   297,   298,   299,   300,   301,   302,   303,   304,    32,
    40,    41,     0
};

static const short yyr1[] = {     0,
    54,    53,    55,    55,    56,    57,    57,    57,    57,    57,
    57,    57,    57,    57,    57,    57,    57,    57,    57,    58,
    59,    60,    61,    62,    63,    64,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    72,    72,    72,    72,    72,
    72,    72,    73,    73,    74,    74,    75,    76,    76,    77,
    77,    78,    79,    79,    80,    80,    81,    82,    82,    83,
    83,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    84,    85,    86,    87,    88,    88,    89,    90,    91,    91,
    91,    92,    92,    93,    94,    94,    95,    95,    96,    96,
    97,    97,    98,    99,    99,    99,    99,   100,   100,   101,
   101,   102,   103,   103,   104,   105,   105,   105,   106,   106,
   107,   108
};

static const short yyr2[] = {     0,
     0,     2,     3,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     6,
     6,     6,     5,     5,     4,     1,     3,     1,     7,     2,
     5,     2,     8,     1,     0,     5,     5,     7,     7,     3,
     7,     7,     0,     1,     1,     3,     2,     0,     3,     1,
     3,     1,     0,     1,     1,     3,     3,     0,     2,     0,
     2,     1,     5,     7,     7,     7,     3,     5,     7,     7,
     7,     1,     9,     4,     1,     2,     7,     1,     0,     3,
     4,     1,     3,     3,     1,     3,     1,     1,     1,     1,
     1,     3,     3,     1,     1,     1,     3,     0,     1,     1,
     3,     5,     1,     3,     1,     3,     5,     7,     0,     2,
     0,     0
};

static const short yydefact[] = {     1,
     0,     0,     5,     2,     0,     4,     0,   111,   112,   112,
   112,   112,     0,   112,     0,   112,     0,   112,   112,   112,
   112,     3,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,     0,     0,     0,     0,
     0,     0,     0,    30,     0,    32,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    28,     0,    26,     0,     0,
     0,     0,     0,     0,    75,     0,   109,     0,   109,     0,
     0,     0,    25,     0,     0,     0,    34,    35,     0,     0,
    74,    76,   105,     0,   103,     0,     0,     0,     0,     0,
    23,    24,    27,     0,    31,     0,     0,    78,     0,   102,
     0,   110,    20,     0,   106,    21,    22,     0,     0,     0,
    79,   104,     0,    29,    62,     0,     0,     0,     0,     0,
     0,     0,     0,    40,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   107,     0,     0,     0,     0,
     0,     0,     0,    58,     0,     0,     0,     0,     0,     0,
     0,    33,     0,     0,     0,     0,     0,    82,     0,     0,
     0,     0,    36,     0,    37,     0,     0,    60,    67,     0,
     0,     0,    43,    53,     0,    73,    80,     0,     0,     0,
    77,   108,     0,     0,     0,     0,     0,    59,     0,     0,
     0,     0,     0,    48,     0,    44,    45,     0,     0,    54,
    55,     0,    87,    89,    90,     0,    84,    85,    88,    81,
    83,    63,    72,     0,     0,     0,    38,    61,    39,    68,
     0,     0,     0,    47,    41,     0,     0,    42,     0,     0,
     0,     0,    91,     0,     0,     0,     0,     0,    52,     0,
    50,    46,    57,    56,     0,     0,     0,    86,    64,    65,
    66,    69,    70,     0,    49,    71,    96,    95,    94,    98,
    93,    92,    51,   100,     0,    99,    97,     0,   101,     0,
     0,     0
};

static const short yydefgoto[] = {   270,
     1,     4,     5,    22,    23,    24,    25,    26,    27,    28,
    57,    58,    29,    30,    31,    32,    33,    78,    96,   195,
   196,   197,   224,   240,   241,   199,   200,   201,   168,   190,
   132,   214,    34,    35,    64,    65,    99,   134,   157,   158,
   207,   208,   209,   232,   233,   261,   265,   266,    36,    84,
    85,    69,    87,    37,    38
};

static const short yypact[] = {-32768,
     1,     2,-32768,-32768,   -38,-32768,    42,-32768,-32768,-32768,
-32768,-32768,   -34,-32768,    17,-32768,    19,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   -19,     0,     3,     9,
    10,    28,    27,-32768,    38,-32768,    43,    44,    45,    47,
    48,   -12,    55,    56,    63,-32768,    -5,-32768,   -12,   -12,
    65,   -12,    69,     7,-32768,    77,    72,    79,    72,    80,
   114,   115,-32768,    28,    78,   118,-32768,-32768,    81,    86,
-32768,-32768,-32768,     8,-32768,    88,   122,   -47,   123,   124,
-32768,-32768,-32768,    92,-32768,    87,    95,-32768,    90,-32768,
    77,-32768,-32768,    97,-32768,-32768,-32768,   127,     6,    93,
-32768,-32768,   -26,-32768,-32768,    96,    98,    99,   100,   101,
   102,   103,   104,-32768,   105,   106,   107,   108,   109,   110,
   111,   131,   119,   -22,   120,-32768,    66,   121,   125,   113,
   126,   128,   132,   129,    66,    66,   130,   133,   117,   134,
   135,-32768,   160,   136,   137,   138,    13,-32768,   139,   140,
   142,   143,-32768,   144,-32768,   145,   146,   147,-32768,   148,
   149,   150,   153,   157,   152,-32768,-32768,   -11,   154,   159,
-32768,-32768,    66,   161,   161,   161,   141,-32768,   156,   163,
    66,   161,   155,   158,   162,   165,-32768,   166,   167,   168,
-32768,   161,-32768,-32768,-32768,   164,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   170,   171,   172,-32768,-32768,-32768,-32768,
   173,   174,   169,-32768,-32768,   153,   181,-32768,   157,   176,
   177,    26,-32768,   -24,   -24,   -24,   -24,   184,-32768,    37,
-32768,-32768,-32768,-32768,   -24,    40,   164,-32768,-32768,-32768,
-32768,-32768,-32768,   169,-32768,-32768,-32768,-32768,-32768,   185,
-32768,-32768,-32768,-32768,   178,   182,-32768,   187,-32768,   183,
   188,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    70,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -54,-32768,-32768,   -81,-32768,-32768,   -53,-32768,-32768,
  -137,  -106,-32768,-32768,-32768,   175,-32768,-32768,-32768,    -3,
-32768,-32768,  -118,-32768,   -69,-32768,-32768,-32768,-32768,-32768,
    83,   -25,   112,-32768,    94
};


#define	YYLAST		239


static const short yytable[] = {   160,
   203,     2,   104,   204,   105,    73,   154,   169,   170,   115,
   116,     7,     6,   117,   118,    42,   204,    81,   100,   205,
   119,   155,   120,   135,   156,   136,   121,    44,   122,    46,
    51,   123,   205,    75,    76,   124,    79,   125,    68,   206,
   126,   127,   128,   129,    74,   212,     3,   130,     8,    52,
   131,   257,    53,   220,     9,    10,    63,   101,    54,    55,
    11,    12,   180,    13,   181,    14,    15,   258,    16,   115,
   116,    56,    17,   117,   118,   247,    59,   248,   215,   216,
    18,    19,   120,   259,    20,   221,   254,    60,   255,    21,
   260,    67,    61,    62,    63,   230,    66,   125,    70,    71,
   126,   127,   128,    39,    40,    41,    72,    43,    77,    45,
   131,    47,    48,    49,    50,   249,   250,   251,   252,    80,
    83,    86,    88,    90,    91,    92,   256,    94,    95,    98,
    97,   102,   103,   106,   107,   108,   109,   114,   110,   111,
   113,   152,   133,    93,   167,   137,   163,   138,   139,   140,
   141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
   151,   165,   153,   159,   161,   166,   172,   173,   162,   164,
   176,   242,   263,   171,   217,   244,   211,   262,   175,   189,
    89,   179,   271,   112,   174,   177,   178,   272,   222,   183,
   182,   184,   185,   186,   187,   188,   194,   191,   192,   193,
   198,   202,   155,   210,   213,   218,   219,   231,   223,     0,
     0,     0,   239,   225,   226,   227,     0,   229,   228,   234,
   235,   236,   237,   238,   243,   245,   246,   253,   264,   267,
   269,   268,     0,     0,     0,     0,     0,     0,    82
};

static const short yycheck[] = {   137,
    12,     1,    50,    28,    52,    11,    29,   145,   146,     4,
     5,    50,    11,     8,     9,    50,    28,    11,    11,    44,
    15,    44,    17,    50,    47,    52,    21,    11,    23,    11,
    50,    26,    44,    59,    60,    30,    62,    32,    51,    51,
    35,    36,    37,    38,    50,   183,    46,    42,     7,    50,
    45,    12,    50,   191,    13,    14,    50,    50,    50,    50,
    19,    20,    50,    22,    52,    24,    25,    28,    27,     4,
     5,    44,    31,     8,     9,    50,    50,    52,   185,   186,
    39,    40,    17,    44,    43,   192,    50,    50,    52,    48,
    51,    44,    50,    50,    50,   202,    50,    32,    44,    44,
    35,    36,    37,    10,    11,    12,    44,    14,    44,    16,
    45,    18,    19,    20,    21,   234,   235,   236,   237,    51,
    44,    50,    44,    44,    11,    11,   245,    50,    11,    44,
    50,    44,    11,    11,    11,    44,    50,    11,    44,    50,
    44,    11,    50,    74,    16,    50,    34,    50,    50,    50,
    50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
    50,    34,    44,    44,    44,    34,    34,    51,    44,    44,
    11,   226,   254,    44,    34,   229,   180,   247,    44,    33,
    69,    44,     0,   101,    51,    50,    50,     0,    34,    50,
    52,    50,    50,    50,    50,    50,    44,    50,    50,    50,
    44,    50,    44,    50,    44,    50,    44,    44,    51,    -1,
    -1,    -1,    44,    52,    50,    50,    -1,    50,    52,    50,
    50,    50,    50,    50,    44,    50,    50,    44,    44,    52,
    44,    50,    -1,    -1,    -1,    -1,    -1,    -1,    64
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__

#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 160 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ CLIENT->recovering = FALSE; CLIENT->isbad = FALSE; ;
    break;}
case 2:
#line 161 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  return FALSE;
;
    break;}
case 4:
#line 167 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  client_parser_do_cleanup(CLIENT);
  CLIENT->recovering = FALSE;	/* no longer recovering */
;
    break;}
case 5:
#line 173 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  client_SET_TAG(CLIENT, yyvsp[0].str);
;
    break;}
case 7:
#line 178 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 8:
#line 179 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 10:
#line 181 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 11:
#line 182 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 12:
#line 183 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 14:
#line 185 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 17:
#line 188 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 19:
#line 190 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ unimplemented(CLIENT); ;
    break;}
case 20:
#line 193 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  str_t *mechanism = yyvsp[-2].str;
  str_t *client_init_challenge = yyvsp[-1].str;

  YYSTYPE client_data, crlf_data;
  const char *clientin = NULL;
  unsigned clientinlen = 0;
  char *serverout;
  const char *errstr;
  unsigned serveroutlen;
  int sasl_result;
  bool_t do_yyerror = FALSE;

  I(mechanism);

  if (client_init_challenge) {
    clientin = str_DATA(client_init_challenge);
    clientinlen = str_LEN(client_init_challenge);
  }

  serverout = NULL;
  sasl_result = sasl_server_start(CLIENT->sasl, str_DATA(mechanism),
				  clientin, clientinlen,
				  &serverout, &serveroutlen,
				  &errstr);
  if (client_init_challenge)
    free(client_init_challenge);

  while (sasl_result == SASL_CONTINUE) {
    /* Send the data to the client, and recieve the next string. */
    pthread_mutex_lock(client_OUTPUT_MUTEX(CLIENT));
    if (! serveroutlen) {
      /* We don't have any data to send */
      client_printf(CLIENT, "+\r\n");
    } else {
      /* Send+free the data... */
      I(serverout);
      client_printf(CLIENT, "+ %l\r\n",
		    serverout, serveroutlen);
    }
    if (serverout) {
      free(serverout);
      serverout = NULL;
    }
    conn_flush(client_CONN(CLIENT));
    pthread_mutex_unlock(client_OUTPUT_MUTEX(CLIENT));

    /* And then wait for a response. */
    sasl_idle(CLIENT->sasl);

    client_SET_STATE(CLIENT, CLIENT_NORMAL);   /* *not* TAG */
    {
      int token = yylex(&client_data, CLIENT);
      if (token != '*' && token != STRING) {
	client_SET_BAD(CLIENT);
	report_error_code(CLIENT, ACAP_ERR_AUTH_NOT_STRING);
	do_yyerror = TRUE;
	sasl_result = SASL_FAIL;
	break;
      }

      if (yylex(&crlf_data, CLIENT) != CRLF) {
	client_SET_BAD(CLIENT);
	report_error_code(CLIENT, ACAP_ERR_AUTH_NOT_CRLF);
	do_yyerror = TRUE;
	sasl_result = SASL_FAIL;
	break;
      }
      if (token == '*') {
	report_error_code(CLIENT, ACAP_ERR_AUTH_CANCELED);
	do_yyerror = TRUE;
	sasl_result = SASL_FAIL;
	break;
      }
    }
    sasl_result = sasl_server_step(CLIENT->sasl,
				   str_DATA(client_data.str),
				   str_LEN(client_data.str),
				   &serverout, &serveroutlen,
				   &errstr);
    free(client_data.str);
  }

  if (sasl_result == SASL_OK)
    conn_SET_MECH(client_CONN(CLIENT), mechanism);
  else
    str_free(&mechanism);

  if (do_yyerror)
    YYERROR;

  I(client_TAG(CLIENT));

  pthread_mutex_lock(client_OUTPUT_MUTEX(CLIENT));
  if (sasl_result == SASL_OK) {
    /* We win! */
    const char *username;
    client_printf(CLIENT, "%t Ok", str_DATA(client_TAG(CLIENT)));
    if (serverout) {
      client_printf(CLIENT, " (SASL %l)", serverout, serveroutlen);
      free(serverout);
    }
    client_printf(CLIENT, " \"Authenticate Complete\"\r\n");
    conn_set_sasl(client_CONN(CLIENT), CLIENT->sasl);
    sasl_result = sasl_getprop(CLIENT->sasl, SASL_USERNAME,
			       (void **)&username);
    if (sasl_result == OK && username) {
      str_t *usernamestr = NULL;
      result_t result;
      result = str_copy_cstr(username, &usernamestr);
      if (result == OK)
	CLIENT->username = usernamestr;
    }
    CLIENT->authenticated = TRUE;
  } else if (sasl_result) {
    client_printf(CLIENT, "%t No %z\r\n",
		  str_DATA(client_TAG(CLIENT)),
		  errstr ? errstr : "Authentication Failed");
  }
  pthread_mutex_unlock(client_OUTPUT_MUTEX(CLIENT));

  free(client_TAG(CLIENT));

  client_parser_forget_cleanup(CLIENT);

  return FALSE;			/* don't close the connection */
;
    break;}
case 23:
#line 326 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  I(client_TAG(CLIENT));
  client_send_result(CLIENT, client_TAG(CLIENT),
		     client_forget_context(CLIENT, yyvsp[-1].str),     
		     "FreeContext Complete", NULL);
  client_parser_do_cleanup(CLIENT);
  return FALSE;			/* don't close the connection */
;
    break;}
case 28:
#line 343 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{;
    break;}
case 30:
#line 348 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  I(client_TAG(CLIENT));
  pthread_mutex_lock(client_OUTPUT_MUTEX(CLIENT));
  client_printf(CLIENT, "* Bye \"Cya Later!\"\r\n");
  client_printf(CLIENT, "%t Ok \"Logout Complete\"\r\n",
		str_DATA(client_TAG(CLIENT)));
  pthread_mutex_unlock(client_OUTPUT_MUTEX(CLIENT));
  client_parser_do_cleanup(CLIENT);
  return TRUE;			/* *do* close the connection */
;
    break;}
case 32:
#line 362 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  I(client_TAG(CLIENT));
  client_send_result(CLIENT, client_TAG(CLIENT), OK, "NoOp Complete", NULL);
  client_parser_do_cleanup(CLIENT);
  return FALSE;			/* don't close the connection */
;
    break;}
case 33:
#line 370 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_start(CLIENT, yyvsp[-4].str, yyvsp[-3].search_modifier, yyvsp[-1].criterion);
  if (result) {
    pthread_mutex_lock(client_OUTPUT_MUTEX(CLIENT));
    client_printf(CLIENT, "%t No %z\r\n",
		  str_DATA(client_TAG(CLIENT)),
		  error_message(result));
    pthread_mutex_unlock(client_OUTPUT_MUTEX(CLIENT));
  } else {
    /* The search has taken all responsibility for this command's data */
    client_parser_forget_cleanup(CLIENT);
  }
  return FALSE;
;
    break;}
case 34:
#line 386 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  if (str_LEN(yyvsp[0].str) == 0) {
    client_SET_BAD(CLIENT);
    report_error_code(CLIENT, ACAP_ERR_BAD_PATH_TOO_SHORT);
    YYERROR;
  }
  yyval.str = yyvsp[0].str;
;
    break;}
case 35:
#line 396 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_alloc(CLIENT, &yyval.search_modifier);
  CHECK_RESULT();
;
    break;}
case 36:
#line 401 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_set_depth(yyvsp[-4].search_modifier, CLIENT, yyvsp[0].number);
  CHECK_RESULT();
  yyval.search_modifier = yyvsp[-4].search_modifier;
;
    break;}
case 37:
#line 407 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_set_hardlimit(yyvsp[-4].search_modifier, CLIENT, yyvsp[0].number);
  CHECK_RESULT();
  yyval.search_modifier = yyvsp[-4].search_modifier;
;
    break;}
case 38:
#line 413 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_set_limit(yyvsp[-6].search_modifier, CLIENT, yyvsp[-2].number, yyvsp[0].number);
  CHECK_RESULT();
  yyval.search_modifier = yyvsp[-6].search_modifier;
;
    break;}
case 39:
#line 419 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_set_makecontext(yyvsp[-6].search_modifier, CLIENT, yyvsp[-2].boolean, yyvsp[-1].boolean, yyvsp[0].str);
  CHECK_RESULT();
  yyval.search_modifier = yyvsp[-6].search_modifier;
;
    break;}
case 40:
#line 425 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_set_noinherit(yyvsp[-2].search_modifier, CLIENT);
  CHECK_RESULT();
  yyval.search_modifier = yyvsp[-2].search_modifier;
;
    break;}
case 41:
#line 431 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_set_return(yyvsp[-6].search_modifier, CLIENT, yyvsp[-1].search_return);
  CHECK_RESULT();
  yyval.search_modifier = yyvsp[-6].search_modifier;
;
    break;}
case 42:
#line 437 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_modifier_set_sort(yyvsp[-6].search_modifier, CLIENT, yyvsp[-1].search_sort);
  CHECK_RESULT();
  yyval.search_modifier = yyvsp[-6].search_modifier;
;
    break;}
case 43:
#line 443 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.search_return = NULL; ;
    break;}
case 44:
#line 444 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.search_return = yyvsp[0].search_return; ;
    break;}
case 45:
#line 447 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  yyval.search_return = yyvsp[0].search_return;
;
    break;}
case 46:
#line 451 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_return_list_append(yyvsp[-2].search_return, yyvsp[0].search_return, &yyval.search_return);
  CHECK_RESULT();
;
    break;}
case 47:
#line 457 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_return_alloc(CLIENT, yyvsp[-1].str, yyvsp[0].search_return_metadatum, &yyval.search_return);
  CHECK_RESULT();
;
    break;}
case 48:
#line 462 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.search_return_metadatum = NULL; ;
    break;}
case 49:
#line 463 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.search_return_metadatum = yyvsp[-1].search_return_metadatum; ;
    break;}
case 50:
#line 466 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  yyval.search_return_metadatum = yyvsp[0].search_return_metadatum;
;
    break;}
case 51:
#line 470 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_return_metadatum_list_append(yyvsp[-2].search_return_metadatum, yyvsp[0].search_return_metadatum, &yyval.search_return_metadatum);
  CHECK_RESULT();
;
    break;}
case 52:
#line 476 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_return_metadatum_alloc(CLIENT, yyvsp[0].str, &yyval.search_return_metadatum);
  CHECK_RESULT();
;
    break;}
case 53:
#line 481 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.search_sort = NULL; ;
    break;}
case 54:
#line 482 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.search_sort = yyvsp[0].search_sort; ;
    break;}
case 55:
#line 485 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  yyval.search_sort = yyvsp[0].search_sort;
;
    break;}
case 56:
#line 489 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_sort_list_append(yyvsp[-2].search_sort, yyvsp[0].search_sort, &yyval.search_sort);
  CHECK_RESULT();
;
    break;}
case 57:
#line 495 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = search_sort_alloc(CLIENT, yyvsp[-2].str, yyvsp[0].str, &yyval.search_sort);
  CHECK_RESULT();
;
    break;}
case 58:
#line 500 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.boolean = FALSE; ;
    break;}
case 59:
#line 501 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.boolean = TRUE; ;
    break;}
case 60:
#line 503 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.boolean = FALSE; ;
    break;}
case 61:
#line 504 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.boolean = TRUE; ;
    break;}
case 62:
#line 507 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_all_alloc(&yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 63:
#line 513 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_and_alloc(yyvsp[-2].criterion, yyvsp[0].criterion, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 64:
#line 519 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_compare_alloc(yyvsp[-4].str, yyvsp[-2].str, yyvsp[0].str, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 65:
#line 525 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_comparestrict_alloc(yyvsp[-4].str, yyvsp[-2].str, yyvsp[0].str, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 66:
#line 531 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_equal_alloc(yyvsp[-4].str, yyvsp[-2].str, yyvsp[0].str, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 67:
#line 537 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_not_alloc(yyvsp[0].criterion, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 68:
#line 543 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_or_alloc(yyvsp[-2].criterion, yyvsp[0].criterion, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 69:
#line 549 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_prefix_alloc(yyvsp[-4].str, yyvsp[-2].str, yyvsp[0].str, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 70:
#line 555 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_range_alloc(yyvsp[-4].number, yyvsp[-2].number, yyvsp[0].str, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 71:
#line 561 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = criterion_substring_alloc(yyvsp[-4].str, yyvsp[-2].str, yyvsp[0].str, &yyval.criterion);
  if (result == OK) result = add_client_data(CLIENT, yyval.criterion);
  CHECK_RESULT();
;
    break;}
case 72:
#line 568 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  if (! str_is_UTF8(yyvsp[0].str)) {
    client_SET_BAD(CLIENT);
    report_error_code(CLIENT, ACAP_ERR_COMPARATOR_NOT_UTF8);
    YYERROR;
  }
  yyval.str = yyvsp[0].str;
;
    break;}
case 74:
#line 580 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_start(CLIENT, yyvsp[-1].store);
  if (result != OK) {
    pthread_mutex_lock(client_OUTPUT_MUTEX(CLIENT));
    client_printf(CLIENT, "%t No %z\r\n",
		  str_DATA(client_TAG(CLIENT)),
		  error_message(result));
    pthread_mutex_unlock(client_OUTPUT_MUTEX(CLIENT));
  } else {
    /* The search takes all responsibility for this command's data */
    client_parser_forget_cleanup(CLIENT);
  }
  return FALSE;
;
    break;}
case 75:
#line 596 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  /* Initial store creation */
  result_t result = store_alloc(CLIENT, yyvsp[0].store_entry, &yyval.store);
  CHECK_RESULT();
;
    break;}
case 76:
#line 602 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  /* Appending another store-entry */
  result_t result = store_append(yyvsp[-1].store, CLIENT, yyvsp[0].store_entry);
  CHECK_RESULT();
  yyval.store = yyvsp[-1].store;
;
    break;}
case 77:
#line 610 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = OK;

  result = store_entry_set_params(yyvsp[-1].store_entry, yyvsp[-2].store_params);
  if (result == OK)
    result = store_entry_set_path(yyvsp[-1].store_entry, CLIENT, yyvsp[-4].str);
  CHECK_RESULT();
  yyval.store_entry = yyvsp[-1].store_entry;
;
    break;}
case 78:
#line 620 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  if (str_LEN(yyvsp[0].str) <= 0
      || str_DATA(yyvsp[0].str)[0] != '/') {
    client_SET_BAD(CLIENT);
    report_error_code(CLIENT, ACAP_ERR_BAD_PATH_NO_SLASH);
    YYERROR;
  }
  if (str_DATA(yyvsp[0].str)[str_LEN(yyvsp[0].str) - 1] == '/') {
    client_SET_BAD(CLIENT);
    report_error_code(CLIENT, ACAP_ERR_BAD_PATH_END_SLASH);
    YYERROR;
  }
  yyval.str = yyvsp[0].str;
;
    break;}
case 79:
#line 636 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_params_alloc(CLIENT, &yyval.store_params);
  CHECK_RESULT();
;
    break;}
case 80:
#line 641 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_params_set_nocreate(yyvsp[-2].store_params);
  CHECK_RESULT();
  yyval.store_params = yyvsp[-2].store_params;
;
    break;}
case 81:
#line 647 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_params_set_unchangedsince(yyvsp[-3].store_params, yyvsp[-1].str);
  CHECK_RESULT();
  yyval.store_params = yyvsp[-3].store_params;
;
    break;}
case 82:
#line 654 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_entry_alloc(CLIENT, yyvsp[0].store_attribute, &yyval.store_entry);
  CHECK_RESULT();
;
    break;}
case 83:
#line 659 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_entry_append(yyvsp[-2].store_entry, CLIENT, yyvsp[0].store_attribute);
  CHECK_RESULT();
  yyval.store_entry = yyvsp[-2].store_entry;
;
    break;}
case 84:
#line 666 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_attribute_set_name(yyvsp[0].store_attribute, CLIENT, yyvsp[-2].str);
  CHECK_RESULT();
  yyval.store_attribute = yyvsp[0].store_attribute;
;
    break;}
case 85:
#line 673 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_attribute_value_alloc(CLIENT, yyvsp[0].str, &yyval.store_attribute);
  CHECK_RESULT();
;
    break;}
case 86:
#line 678 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  yyval.store_attribute = yyvsp[-1].store_attribute;			/* just pop it up... */
;
    break;}
case 87:
#line 682 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.str = (str_t *)-1; ;
    break;}
case 88:
#line 683 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 89:
#line 685 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.str = NULL; ;
    break;}
case 90:
#line 686 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 91:
#line 689 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  /* Initial recursion */
  result_t result = store_attribute_alloc(CLIENT, yyvsp[0].store_metadatum, &yyval.store_attribute);
  CHECK_RESULT();
;
    break;}
case 92:
#line 695 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  /* Adding a metadatum */
  result_t result = store_attribute_append(yyvsp[-2].store_attribute, CLIENT, yyvsp[0].store_metadatum);
  CHECK_RESULT();
  yyval.store_attribute = yyvsp[-2].store_attribute;
;
    break;}
case 93:
#line 703 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result;
  const acap_token_t *token;

  token = acap_token_lookup(str_DATA(yyvsp[-2].str), str_LEN(yyvsp[-2].str));
  if (! token) {
    client_SET_BAD(CLIENT);
    report_error_code(CLIENT, ACAP_ERR_BAD_METADATUM_TYPE);
    YYERROR;
  }
  result = store_metadatum_set_name(yyvsp[0].store_metadatum, CLIENT, token->value);
  CHECK_RESULT();
  yyval.store_metadatum = yyvsp[0].store_metadatum;
;
    break;}
case 94:
#line 719 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_metadatum_str_alloc(CLIENT, yyvsp[0].str, &yyval.store_metadatum);
  CHECK_RESULT();
;
    break;}
case 95:
#line 724 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_metadatum_nil_alloc(CLIENT, &yyval.store_metadatum);
  CHECK_RESULT();
;
    break;}
case 96:
#line 729 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_metadatum_default_alloc(CLIENT, &yyval.store_metadatum);
  CHECK_RESULT();
;
    break;}
case 97:
#line 734 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  yyval.store_metadatum = yyvsp[-1].store_metadatum;
;
    break;}
case 98:
#line 738 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_metadatum_multi_alloc(CLIENT, NULL, &yyval.store_metadatum);
  CHECK_RESULT();
;
    break;}
case 99:
#line 742 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.store_metadatum = yyvsp[0].store_metadatum; ;
    break;}
case 100:
#line 745 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_metadatum_multi_alloc(CLIENT, yyvsp[0].str, &yyval.store_metadatum);
  CHECK_RESULT();
;
    break;}
case 101:
#line 750 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  result_t result = store_metadatum_multi_append(yyvsp[-2].store_metadatum, CLIENT, yyvsp[0].str);
  CHECK_RESULT();
  yyval.store_metadatum = yyvsp[-2].store_metadatum;
;
    break;}
case 105:
#line 762 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{;
    break;}
case 109:
#line 769 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.str=NULL; ;
    break;}
case 110:
#line 769 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{ yyval.str = yyvsp[0].str; ;
    break;}
case 111:
#line 772 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  /* We just use this to check, inline, whether we're not authentic */
  if (CLIENT->authenticated) {
    pthread_mutex_lock(client_OUTPUT_MUTEX(CLIENT));
    client_printf(CLIENT, "%t Bad \"Already Authenticated\"\r\n",
		  str_DATA(client_TAG(CLIENT)));
    pthread_mutex_unlock(client_OUTPUT_MUTEX(CLIENT));
    YYERROR;
  }
;
    break;}
case 112:
#line 784 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"
{
  /* We just use this to check, inline, whether we're authentic */
  if (! CLIENT->authenticated) {
    pthread_mutex_lock(client_OUTPUT_MUTEX(CLIENT));
    client_printf(CLIENT, "%t Bad \"Authenticate First\"\r\n",
		  str_DATA(client_TAG(CLIENT)));
    pthread_mutex_unlock(client_OUTPUT_MUTEX(CLIENT));
    YYERROR;
  }
;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 795 "/home/rob/src/acapd-2_2/acapd/parse.acap.y"


static void
unimplemented(client_t *client)
{
  pthread_mutex_lock(client_OUTPUT_MUTEX(client));
  client_printf(client, "%t No \"Unimplemented\"\r\n",
		str_DATA(client_TAG(client)));
  conn_flush(client_CONN(client));
  pthread_mutex_unlock(client_OUTPUT_MUTEX(client));
  client_parser_do_cleanup(client);
}

static void
report_error(client_t *client, const char *msg)
{
  const char *tag;

  I(client);
  I(msg);

  if (client_TAG(client))
    tag = str_DATA(client_TAG(client));
  else
    tag = "*";

  pthread_mutex_lock(client_OUTPUT_MUTEX(client));
  client_printf(client, "%t %t %z\r\n",
		tag,
		client_IS_BAD(client) ? "Bad" : "No",
		msg);
  pthread_mutex_unlock(client_OUTPUT_MUTEX(client));

  client->recovering = TRUE;
}

static void
report_error_code(client_t *client, result_t code)
{
  report_error(client, error_message(code));
}

static void
yyerror(char *s)
{
  client_t *client = NULL;

  if (client_current(&client))
    return;

  client_SET_BAD(client);

  report_error(client, s);
}

static result_t
add_client_data(client_t *client,
		void *data)
{
  result_t result = client_parser_add_cleanup(client, &free, data);
  if (result != OK)
    free(data);
  return result;
}
